
/* ------------------------------------------------------------------------
   A. Veneziani - Esempio di programmazione ad oggetti con due classi
                  La classe Usa Pila utilizza la classe Pila, che a
                  sua volta e' utile per svolgere operazioni fornite
                  in notazione RPN a Usa Pila

                  Scritto in C++ Builder 6

  ------------------------------------------------------------------------- */                  

#include "conio.h"
#include <iostream>

using namespace std;

const DIMENSIONE_STACK = 30;

// classe che implementa un oggetto che
// effettua le funzionalita' tipiche di uno stack di interi
class Pila {

    int top;
    int v[DIMENSIONE_STACK];

    public:

    Pila()    // costruttore con inizializzazione del livello
    {
       top = 0;
    }

    // metodi che implementano le classiche operazioni
    // di push e pop (inserimento ed estrazione dalla pila)
    void push(int n)
    {
       v[top] = n;
       top++;
    }

    int pop()
    {
       top--;
       return(v[top]);
    }

    // altri metodi che svolgono utili
    // operazioni ausiliarie

    // indica il munero degli elementi presenti nella pila
    int n_elem()
    {
       return(top);
    }

    // stampa tuttio il contenuto della pila
    void stampa()
    {
        int i;

        for (i = (top - 1); i >= 0; i--)  cout << v[i] << endl;
    }

    // legge l'elemento in cima alla pila senza rimuoverlo
    int leggi_cima()
    {
        return(v[top - 1]);
    }

    // metodo che controlla se la pila e' piena
    bool e_pieno()
    {
       if (top == DIMENSIONE_STACK)
          return(true);
       else
          return(false);
    }

    // metodo che controlla se la pila e' vuota
    bool e_vuoto()
    {
       if (top == 0)
          return(true);
       else
          return(false);
    }
};


// classe che utilizza Pila per effettuare
// alcune operazioni aritmetiche tramite essa
class Usa_Pila
{
    // dichiara un oggetto Pila come variabile di stato di Usa_Pila
    Pila P;

    // funzione che individua se il carattere
    // e' un operatore (+, -, *)
    bool e_op(char ch)
    {
        switch (ch)
        {
            case '+':  return(true);  break;
            case '-':  return(true);  break;
            case '*':  return(true);  break;
            default:   return(false);
        }
    }

    // metodi privati
    int somma()
    {
        int op1, op2, r;

        op1 = P.pop();
        op2 = P.pop();

        r = op1 + op2;

        P.push(r);
    }

    int sottrai()
    {
        int op1, op2, r;

        op1 = P.pop();
        op2 = P.pop();

        r = op1 - op2;

        P.push(r);
    }

    int moltiplica()
    {
        int op1, op2, r;

        op1 = P.pop();
        op2 = P.pop();

        r = op1 * op2;

        P.push(r);
    }

    public:

    // metodo pubblico  -
    // effettua il calcolo della espressione
    int calcola(char* st)
    {
        int i,op;

        // scandisce tutti i caratteri della stringa
        // (espressione di calcolo)
        for (i = 0; i < strlen(st); i++)
        {
            // se il carattere non e' uno spazio...
            if (st[i] != ' ')
            {
                // individua se e' un operatore
                if (e_op(st[i]))
                {
                    // controlla di che operatore si tratta
                    // (ammessi solo +, -, *)
                    switch (st[i])
                    {
                        case '+':  somma();  break;
                        case '-':  sottrai();  break;
                        case '*':  moltiplica();  break;
                    }
                }
                else    // altrimenti e' una (singola) cifra...
                {
                    // ricava l'equivalente numerico
                    op = st[i] - 48;
                    // inserisce il dato nello stack
                    P.push(op);
                }

                cout << endl << endl;
                P.stampa();
                cout << "-----";
            }
        }

        // rende il risultato (presente sulla cime dello stack)
        return(P.leggi_cima());
    }

};

void main()
{
   Usa_Pila Up;

    // applica il metodo di per il calcolo
   // di una espressione in formato RPN
   cout << endl << endl << "Risultato: " <<
   Up.calcola("1 2 3 + - 4 * 2  8 + +");

   getch();
}
